/*
** 2025 April 6
**
** The author disclaims copyright to this source code.  In place of a
** legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
*/

#if 0
# ifndef TEAISH_LOAD_PREFIX
#  define TEAISH_LOAD_PREFIX Test
# endif
# ifndef TEAISH_PKGNAME
#  define TEAISH_PKGNAME "test"
# endif
# ifndef TEAISH_VERSION
#  define TEAISH_VERSION "0.0.1"
# endif
#endif

#define concatty_(A,B) A ## B
#define concatty(A,B) concatty_(A,B)

#define CMD_NAME concatty(TEAISH_LOAD_PREFIX,_Cmd)
#define INIT_NAME concatty(TEAISH_LOAD_PREFIX,_Init)

#include <tcl.h>

/**
   Returns the string "Hello, World!"
*/
static int
CMD_NAME(ClientData cdata, Tcl_Interp *interp, int objc, Tcl_Obj *const objv[]){
  Tcl_SetObjResult(interp, Tcl_NewStringObj("Hello, World!", -1));
  return TCL_OK;
}

/**
   Tcl init routine for this extension.

   https://wiki.tcl-lang.org/page/Tcl_CreateObjCommand
*/
#ifdef _WIN32
__declspec(dllexport)
#endif
extern int DLLEXPORT INIT_NAME(Tcl_Interp *interp){
  if (Tcl_InitStubs(interp, TCL_VERSION, 0) == NULL) {
    return TCL_ERROR;
  }
  if (Tcl_PkgProvide(interp, TEAISH_PKGNAME, TEAISH_VERSION) == TCL_ERROR) {
    return TCL_ERROR;
  }
  Tcl_CreateObjCommand(interp, TEAISH_PKGNAME, CMD_NAME, NULL, NULL);
  return TCL_OK;
}

#undef INIT_NAME
#undef CMD_NAME
#undef concatty
#undef concatty_
